--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")

local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}
local InkedColorsHightlight = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 0.1}

local HightlightTex = "Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsHoverTex"
local PushedTex = "Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsPushedTex"
local CountFont = "Interface\\Addons\\Inked\\Fonts\\SF Comic Script.ttf"
local CountFontSize = 13
local CountFontOutline = "OUTLINE"
local NameFont = "Interface\\Addons\\Inked\\Fonts\\Roboto.ttf"
local NameFontSize = 9
local NameFontOutline = "THINOUTLINE"

local ButtonSize = 40
local MySpacing = 1
local BorderSize = 12
local BorderPadding = 0
local Shiftindex = GetShapeshiftFormID()

local MoverAB7 = CreateFrame("Frame","AB7Drag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	MoverAB7:SetSize((ButtonSize * 12)+12, ButtonSize)
	--MoverAB7:SetPoint("CENTER", UIParent,"BOTTOM",220.5, 65.5)
	MoverAB7:SetFrameStrata("FULLSCREEN_DIALOG")
	MoverAB7:SetClampedToScreen(true)
	MoverAB7:SetClampRectInsets(0, 0, 0,0)
local MoverAB7Text  = MoverAB7:CreateFontString(nil, "OVERLAY")
	MoverAB7Text:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.TTF", 15, "OUTLINE")
	MoverAB7Text:SetPoint("CENTER",MoverAB7,"CENTER", 0,0); 
	MoverAB7Text:SetText("")
	
	local function CreateButtonTexture(frame)
	local ButtonForeground = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		  ButtonForeground:SetAllPoints(frame)
		  ButtonForeground:SetFrameLevel(4)
		  ButtonForeground:SetBackdrop({bgFile = "Interface\\Addons\\Inked\\Graphics\\Buttons\\InkedButton",
			edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\InkedBorder",
			edgeSize = 16,
			insets = {top = 4, left = 4, bottom = 4, right = 4}})
		ButtonForeground:SetBackdropColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
		ButtonForeground:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,0)
end

local function UpdateMe()
	if(Inked.db.profile.lockframes == false) then
		if Inked.db.profile.AB7Enable == true then
			local point, relativeTo, relativePoint, xOfs, yOfs = MoverAB7:GetPoint(n)
				Inked.db.profile.MoverAB7X = xOfs
				Inked.db.profile.MoverAB7Y = yOfs
				Inked.db.profile.MoverAB7Point = point
				--Inked.db.profile.MoverAB7RelPoint = relativePoint
				--print(point.." "..relativePoint)
				MoverAB7Text:SetText("Inked Bar 7")	
		end
	end	
end	

local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe) 
	
local function CreateMoverBackdrop(frame)
	frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
	insets = {top = -2, left = -2, bottom = -2, right = -2}})
	frame:SetBackdropColor(0,0.55,0.95,0.45)
	frame:SetBackdropBorderColor(0,0,0,1)
end



local function MakeBar7()
	if Inked.db.profile.UseActionBars == false then return end
	if UnitClass("player") == "Druid" or UnitClass("player") == "Rogue" then return end
	-- local Shiftindex = GetShapeshiftFormID()
	-- print(Shiftindex)
	local InkedBar7 = CreateFrame("Frame", nil, UIParent, BackdropTemplateMixin and "BackdropTemplate")
	InkedBar7:SetAllPoints(MoverAB7)

	ButtonSize = Inked.db.profile.AB7ButtonSize
	local ThisTexture = ("Interface\\Addons\\Inked\\Graphics\\Buttons\\InkedButtons")
		InkedBar7config = {
				outOfRangeColoring = "button",
				tooltip = "enabled",
				showGrid = true,
				colors = {
					range = { 0.8, 0.1, 0.1 },
					mana = { 0.5, 0.5, 1.0 }
				},
				hideElements = {
					macro = false,
					hotkey = false,
					equipped = false,
				},
				keyBoundTarget = false,
				clickOnDown = false,
				flyoutDirection = "UP",	
			}
		CreateFrame("Frame", "InkedActionBar7", UIParent, "SecureHandlerStateTemplate")
		InkedActionBar7:SetParent(InkedBar7)
		InkedActionBar7:SetPoint("RIGHT", InkedBar7,"LEFT",ButtonSize/2,0)
		RegisterStateDriver(InkedActionBar7, "vehicle", "[petbattle][overridebar] hide;show")	
		InkedActionBar7:SetAttribute("_onstate-vehicle", [[
			if newstate == "hide" then
			  self:Hide();
			else
			  self:Show();
			end
		]]) 
		
		--local ButtonSize = Inked.db.profile.ButtonSize
		--local lastnumber = 73 + Inked.db.profile.Bar7ButtonNumber
		local lastnumber = 73 + 12
			

	if Inked.db.profile.AB7Enable == true then
		InkedBar7:Show()
		if Inked.db.profile.Bar7BarLayout == 1 then
					for i = 73,lastnumber-1 do -- bar 1
						local Inkedbutton7 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar7)
						Inkedbutton7:SetPoint("CENTER", InkedActionBar7,"CENTER",(i-73)*(ButtonSize+MySpacing*1.5),0)
						Inkedbutton7:Show()
						Inkedbutton7:SetState(0, "action", i)
						Inkedbutton7:SetSize(ButtonSize,ButtonSize)
						Inkedbutton7:SetAttribute("buttonlock",true)
						Inkedbutton7:SetAttribute("checkselfcast",true)
						Inkedbutton7:SetAttribute("checkfocuscast",true)
						Inkedbutton7:UpdateConfig(InkedBar7config)
					end
				--	InkedActionBar7:SetPoint("LEFT", InkedBar7,0,0)
				elseif Inked.db.profile.Bar7BarLayout == 2 then
					MoverAB7:SetSize(ButtonSize*6, ButtonSize* 2)
					InkedActionBar7:SetPoint("LEFT", InkedBar7,4,20)
					if lastnumber > 78 then
						for i = 73,78 do -- bar 1
							local Inkedbutton7 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar7)
							Inkedbutton7:SetPoint("CENTER", InkedActionBar7,"CENTER",(i-73)*ButtonSize,0)
							Inkedbutton7:Show()
							Inkedbutton7:SetState(0, "action", i)
							Inkedbutton7:SetSize(ButtonSize,ButtonSize)
							Inkedbutton7:SetAttribute("buttonlock",true)
							Inkedbutton7:SetAttribute("checkselfcast",true)
							Inkedbutton7:SetAttribute("checkfocuscast",true)
							Inkedbutton7:UpdateConfig(InkedBar7config)
						end
						for i = 79,lastnumber-1 do -- bar 1
							local Inkedbutton7a = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar7)
							Inkedbutton7a:SetPoint("CENTER", InkedActionBar7,"CENTER",(i-79)*ButtonSize,-(ButtonSize+1))
							Inkedbutton7a:Show()
							Inkedbutton7a:SetState(0, "action", i)
							Inkedbutton7a:SetSize(ButtonSize,ButtonSize)
							Inkedbutton7a:SetAttribute("buttonlock",true)
							Inkedbutton7a:SetAttribute("checkselfcast",true)
							Inkedbutton7a:SetAttribute("checkfocuscast",true)
							Inkedbutton7a:UpdateConfig(InkedBar7config)
						end
					else
						for i = 73,lastnumber-1 do -- bar 1
							local Inkedbutton7 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar7)
							Inkedbutton7:SetPoint("CENTER", InkedActionBar7,"CENTER",(i-73)*ButtonSize,0)
							Inkedbutton7:Show()
							Inkedbutton7:SetState(0, "action", i)
							Inkedbutton7:SetSize(ButtonSize,ButtonSize)
							Inkedbutton7:SetAttribute("buttonlock",true)
							Inkedbutton7:SetAttribute("checkselfcast",true)
							Inkedbutton7:SetAttribute("checkfocuscast",true)
							Inkedbutton7:UpdateConfig(InkedBar7config)
						end					
					end
							
				elseif Inked.db.profile.Bar7BarLayout == 3 then
					MoverAB7:SetSize(ButtonSize*4, ButtonSize* 3)
					InkedActionBar7:SetPoint("LEFT", InkedBar7,8,33)
					if lastnumber > 76 then
						for i = 73,76 do -- bar 1
							local Inkedbutton7 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar7)
							Inkedbutton7:SetPoint("CENTER", InkedActionBar7,"CENTER",(i-73)*ButtonSize,0)
							Inkedbutton7:Show()
							Inkedbutton7:SetState(0, "action", i)
							Inkedbutton7:SetSize(ButtonSize,ButtonSize)
							Inkedbutton7:SetAttribute("buttonlock",true)
							Inkedbutton7:SetAttribute("checkselfcast",true)
							Inkedbutton7:SetAttribute("checkfocuscast",true)
							Inkedbutton7:UpdateConfig(InkedBar7config)
						end
						for i = 77,80 do -- bar 1
							local Inkedbutton7a = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar7)
							Inkedbutton7a:SetPoint("CENTER", InkedActionBar7,"CENTER",(i-77)*ButtonSize,-(ButtonSize+1))
							Inkedbutton7a:Show()
							Inkedbutton7a:SetState(0, "action", i)
							Inkedbutton7a:SetSize(ButtonSize,ButtonSize)
							Inkedbutton7a:SetAttribute("buttonlock",true)
							Inkedbutton7a:SetAttribute("checkselfcast",true)
							Inkedbutton7a:SetAttribute("checkfocuscast",true)
							Inkedbutton7a:UpdateConfig(InkedBar7config)
						end
						for i = 81,lastnumber-1 do -- bar 1
							local Inkedbutton7b = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar7)
							Inkedbutton7b:SetPoint("CENTER", InkedActionBar7,"CENTER",(i-81)*ButtonSize,-(ButtonSize+1)*2)
							Inkedbutton7b:Show()
							Inkedbutton7b:SetState(0, "action", i)
							Inkedbutton7b:SetSize(ButtonSize,ButtonSize)
							Inkedbutton7b:SetAttribute("buttonlock",true)
							Inkedbutton7b:SetAttribute("checkselfcast",true)
							Inkedbutton7b:SetAttribute("checkfocuscast",true)
							Inkedbutton7b:UpdateConfig(InkedBar7config)
						end
					else
						for i = 73,lastnumber-1 do -- bar 1
							local Inkedbutton7 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar7)
							Inkedbutton7:SetPoint("CENTER", InkedActionBar7,"CENTER",(i-73)*ButtonSize,0)
							Inkedbutton7:Show()
							Inkedbutton7:SetState(0, "action", i)
							Inkedbutton7:SetSize(ButtonSize,ButtonSize)
							Inkedbutton7:SetAttribute("buttonlock",true)
							Inkedbutton7:SetAttribute("checkselfcast",true)
							Inkedbutton7:SetAttribute("checkfocuscast",true)
							Inkedbutton7:UpdateConfig(InkedBar7config)
						end					
					end
				
				elseif Inked.db.profile.Bar7BarLayout == 4 then
					InkedActionBar7:SetPoint("TOPLEFT", InkedBar7,"BOTTOMRIGHT",-15,15)
					MoverAB7:SetSize(ButtonSize, ButtonSize* 12)
					for i = 73,lastnumber-1 do -- bar 1
						local Inkedbutton7 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar7)
						Inkedbutton7:SetPoint("CENTER", InkedActionBar7,"CENTER",0,(i-73)*ButtonSize)
						Inkedbutton7:Show()
						Inkedbutton7:SetState(0, "action", i)
						Inkedbutton7:SetSize(ButtonSize,ButtonSize)
						Inkedbutton7:SetAttribute("buttonlock",true)
						Inkedbutton7:SetAttribute("checkselfcast",true)
						Inkedbutton7:SetAttribute("checkfocuscast",true)
						Inkedbutton7:UpdateConfig(InkedBar7config)
					end
				elseif Inked.db.profile.Bar7BarLayout == 5 then
					MoverAB7:SetSize(ButtonSize*2, ButtonSize* 6)
					InkedActionBar7:SetPoint("TOPLEFT", InkedBar7,"BOTTOMRIGHT",10,15)
					if lastnumber > 78 then
						for i = 73,78 do -- bar 1
							local Inkedbutton7 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar7)
							Inkedbutton7:SetPoint("CENTER", InkedActionBar7,"CENTER",0,(i-73)*ButtonSize)
							Inkedbutton7:Show()
							Inkedbutton7:SetState(0, "action", i)
							Inkedbutton7:SetSize(ButtonSize,ButtonSize)
							Inkedbutton7:SetAttribute("buttonlock",true)
							Inkedbutton7:SetAttribute("checkselfcast",true)
							Inkedbutton7:SetAttribute("checkfocuscast",true)
							Inkedbutton7:UpdateConfig(InkedBar7config)
						end
						for i = 79,lastnumber-1 do -- bar 1
							local Inkedbutton7a = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar7)
							Inkedbutton7a:SetPoint("CENTER", InkedActionBar7,"CENTER",-ButtonSize,(i-79)*ButtonSize)
							Inkedbutton7a:Show()
							Inkedbutton7a:SetState(0, "action", i)
							Inkedbutton7a:SetSize(ButtonSize,ButtonSize)
							Inkedbutton7a:SetAttribute("buttonlock",true)
							Inkedbutton7a:SetAttribute("checkselfcast",true)
							Inkedbutton7a:SetAttribute("checkfocuscast",true)
							Inkedbutton7a:UpdateConfig(InkedBar7config)
						end
					else
						for i = 73,lastnumber-1 do -- bar 1
							local Inkedbutton7 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar7)
							Inkedbutton7:SetPoint("CENTER", InkedActionBar7,"CENTER",(i-73)*ButtonSize,0)
							Inkedbutton7:Show()
							Inkedbutton7:SetState(0, "action", i)
							Inkedbutton7:SetSize(ButtonSize,ButtonSize)
							Inkedbutton7:SetAttribute("buttonlock",true)
							Inkedbutton7:SetAttribute("checkselfcast",true)
							Inkedbutton7:SetAttribute("checkfocuscast",true)
							Inkedbutton7:UpdateConfig(InkedBar7config)
						end					
					end
				
				elseif Inked.db.profile.Bar7BarLayout == 6 then
					MoverAB7:SetSize(ButtonSize*3, ButtonSize*4)
					InkedActionBar7:SetPoint("LEFT", InkedBar7,10,52)
					if lastnumber > 75 then
						for i = 73,75 do -- bar 1
							local Inkedbutton7 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar7)
							Inkedbutton7:SetPoint("CENTER", InkedActionBar7,"CENTER",(i-73)*ButtonSize,0)
							Inkedbutton7:Show()
							Inkedbutton7:SetState(0, "action", i)
							Inkedbutton7:SetSize(ButtonSize,ButtonSize)
							Inkedbutton7:SetAttribute("buttonlock",true)
							Inkedbutton7:SetAttribute("checkselfcast",true)
							Inkedbutton7:SetAttribute("checkfocuscast",true)
							Inkedbutton7:UpdateConfig(InkedBar7config)
						end
						for i = 76,78 do -- bar 1
							local Inkedbutton7a = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar7)
							Inkedbutton7a:SetPoint("CENTER", InkedActionBar7,"CENTER",(i-76)*ButtonSize,-(ButtonSize+1))
							Inkedbutton7a:Show()
							Inkedbutton7a:SetState(0, "action", i)
							Inkedbutton7a:SetSize(ButtonSize,ButtonSize)
							Inkedbutton7a:SetAttribute("buttonlock",true)
							Inkedbutton7a:SetAttribute("checkselfcast",true)
							Inkedbutton7a:SetAttribute("checkfocuscast",true)
							Inkedbutton7a:UpdateConfig(InkedBar7config)
						end
						for i = 79,81 do -- bar 1
							local Inkedbutton7b = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar7)
							Inkedbutton7b:SetPoint("CENTER", InkedActionBar7,"CENTER",(i-79)*ButtonSize,-(ButtonSize+1)*2)
							Inkedbutton7b:Show()
							Inkedbutton7b:SetState(0, "action", i)
							Inkedbutton7b:SetSize(ButtonSize,ButtonSize)
							Inkedbutton7b:SetAttribute("buttonlock",true)
							Inkedbutton7b:SetAttribute("checkselfcast",true)
							Inkedbutton7b:SetAttribute("checkfocuscast",true)
							Inkedbutton7b:UpdateConfig(InkedBar7config)
						end
						for i = 82,lastnumber-1 do -- bar 1
							local Inkedbutton7c = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar7)
							Inkedbutton7c:SetPoint("CENTER", InkedActionBar7,"CENTER",(i-82)*ButtonSize,-(ButtonSize+1)*3)
							Inkedbutton7c:Show()
							Inkedbutton7c:SetState(0, "action", i)
							Inkedbutton7c:SetSize(ButtonSize,ButtonSize)
							Inkedbutton7c:SetAttribute("buttonlock",true)
							Inkedbutton7c:SetAttribute("checkselfcast",true)
							Inkedbutton7c:SetAttribute("checkfocuscast",true)
							Inkedbutton7c:UpdateConfig(InkedBar7config)
						end
					else
						for i = 73,lastnumber-1 do -- bar 1
							local Inkedbutton7 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar7)
							Inkedbutton7:SetPoint("CENTER", InkedActionBar7,"CENTER",(i-73)*ButtonSize,0)
							Inkedbutton7:Show()
							Inkedbutton7:SetState(0, "action", i)
							Inkedbutton7:SetSize(ButtonSize,ButtonSize)
							Inkedbutton7:SetAttribute("buttonlock",true)
							Inkedbutton7:SetAttribute("checkselfcast",true)
							Inkedbutton7:SetAttribute("checkfocuscast",true)
							Inkedbutton7:UpdateConfig(InkedBar7config)
						end					
					end
				
				end -- end folds
					for i = 73,84 do -- bar 6
							local normalBar7 = _G["InkedbuttonBar"..i]							
						--	CreateButtonTexture(normalBar7)
							normalBar7.NormalTexture:SetTexture("")
							local Highlight = normalBar7:GetHighlightTexture()						
							local Pushed = normalBar7:GetPushedTexture()
							Highlight:SetTexture(HightlightTex)
							Highlight:SetVertexColor(InkedColorsHightlight.r,InkedColorsHightlight.g,InkedColorsHightlight.b,InkedColorsHightlight.a)
							Pushed:SetTexture(PushedTex)							
							local count = _G[normalBar7:GetName()..'Count']
							count:SetFont(CountFont,CountFontSize,CountFontOutline)
							local name = _G[normalBar7:GetName()..'Name']
							name:SetWidth(55)
							name:SetFont(NameFont,NameFontSize,NameFontOutline)
							normalBar7:CreateBeautyBorder(BorderSize)
							normalBar7:SetBeautyBorderPadding(BorderPadding)
							normalBar7:SetBeautyBorderTexture("white")
							--normalBar7:SetBeautyBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
							if Inked.db.profile.ClassABColor == true then
								normalBar7:SetBeautyBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
							elseif Inked.db.profile.ClassABColor == false then
								if Inked.db.profile.CustomABColor == true then
									normalBar7:SetBeautyBorderColor(Inked.db.profile.ABColorR,Inked.db.profile.ABColorG,Inked.db.profile.ABColorB,Inked.db.profile.ABColorA)
								elseif Inked.db.profile.CustomABColor == false then
									normalBar7:SetBeautyBorderColor(1,1,1,1)
								end
							end
		
						end
		end
		if(Inked.db.profile.lockframes == false) then
			MoverAB7:ClearAllPoints()
			if Inked.db.profile.MoverAB7Point == nil then
				MoverAB7:SetPoint("BOTTOM", UIParent,Inked.db.profile.MoverAB7X,Inked.db.profile.MoverAB7Y)
			else
				MoverAB7:SetPoint(Inked.db.profile.MoverAB7Point, UIParent,Inked.db.profile.MoverAB7X,Inked.db.profile.MoverAB7Y)
			end
			if Inked.db.profile.AB7Enable == true then
				CreateMoverBackdrop(MoverAB7)
				MoverAB7:SetMovable(true)
				MoverAB7:EnableMouse(true)
				MoverAB7:RegisterForDrag("LeftButton")
				MoverAB7:SetScript("OnDragStart", MoverAB7.StartMoving)
				MoverAB7:SetScript("OnDragStop", MoverAB7.StopMovingOrSizing)
				MoverAB7:SetUserPlaced(true)
			end
			elseif Inked.db.profile.MoverAB7Point == nil then
				MoverAB7:SetPoint("BOTTOM", UIParent,Inked.db.profile.MoverAB7X,Inked.db.profile.MoverAB7Y)
			else
				MoverAB7:SetPoint(Inked.db.profile.MoverAB7Point, UIParent,Inked.db.profile.MoverAB7X,Inked.db.profile.MoverAB7Y)
		end
end		
		local InkedLoginFrame=CreateFrame("Frame")
		InkedLoginFrame:RegisterEvent("PLAYER_LOGIN")
		InkedLoginFrame:RegisterEvent("CINEMATIC_STOP")
		InkedLoginFrame:SetScript("OnEvent", function(self, event) 
			MakeBar7()									
		end)